<?php

require 'includes.php';

$layout = GetPage('home', '{{ST:home}}');

if(isset($_GET['id'])){
	$layout->AddContentById('home_title', $db->get_var("SELECT name FROM " . TABLES_PREFIX . "categories WHERE id = " . intval($_GET['id'])));
	$layout->AddContentById('breadcrumbs', ' <li><a href="index.php">{{ST:home}}</a> <span class="divider">/</span> </li><li class="active">'.$db->get_var("SELECT name FROM " . TABLES_PREFIX . "categories WHERE id = " . intval($_GET['id'])).'</li>');
}elseif(isset($_GET['mine'])){
	$layout->AddContentById('home_title', '{{ST:your_threads}}');
	$layout->AddContentById('breadcrumbs', ' <li><a href="index.php">{{ST:home}}</a> <span class="divider">/</span> </li><li class="active">{{ST:your_threads}}</li>');
}elseif(isset($_GET['following'])){
	$layout->AddContentById('home_title', '{{ST:your_subscriptions}}');
	$layout->AddContentById('breadcrumbs', ' <li><a href="index.php">{{ST:home}}</a> <span class="divider">/</span> </li><li class="active">{{ST:your_subscriptions}}</li>');

}else{
	$layout->AddContentById('home_title', '{{ST:all_forums}}');
	$layout->AddContentById('breadcrumbs', ' <li class="active">{{ST:home}}</li>');
}

if(isset($_GET['message']) AND $_GET['message'] != ''){
	
	if($_GET['message'] == 'deleted'){
		$layout->AddContentById('alert', $layout->GetContent('alert'));
		$layout->AddContentById('alert_nature', ' alert-success');
		$layout->AddContentById('alert_heading', '{{ST:success}}!');
		$layout->AddContentById('alert_message', '{{ST:the_post_and_its_children_have_been_deleted}}');
	}
}



if(isset($_GET['page'])){
	$page = intval($_GET['page']);
}else{
	$page = 1;
}
$rows = ROWS_PER_PAGE;
$offset = ($page - 1) * $rows;

if(isset($_GET['id'])){
	$latest = $db->get_results("SELECT * FROM " . TABLES_PREFIX . "posts WHERE is_question = 'y' AND category_id = ".intval($_GET['id'])." AND flagged = 'n' ORDER BY date DESC LIMIT $offset, $rows");
	$number_of_records = count($db->get_results("SELECT * FROM " . TABLES_PREFIX . "posts WHERE is_question = 'y' AND category_id = ".intval($_GET['id'])." AND flagged = 'n'" ));
}elseif(isset($_GET['mine'])){
	$latest = $db->get_results("SELECT * FROM " . TABLES_PREFIX . "posts WHERE is_question = 'y' AND user_id = ".intval(Users_CurrentUserId())." AND flagged = 'n' ORDER BY date DESC LIMIT $offset, $rows");
	$number_of_records = count($db->get_results("SELECT * FROM " . TABLES_PREFIX . "posts WHERE is_question = 'y' AND user_id = ".intval(Users_CurrentUserId())." AND flagged = 'n'" ));
}elseif(isset($_GET['following'])){
	$tables = TABLES_PREFIX . 'posts, ' . TABLES_PREFIX .'posts_following';
	$select = TABLES_PREFIX . 'posts.*';
	$where = TABLES_PREFIX . 'posts.id = ' . TABLES_PREFIX .'posts_following.post_id AND '. TABLES_PREFIX .'posts_following.user_id = ' . intval(Users_CurrentUserId());
	$latest = $db->get_results("SELECT $select FROM $tables WHERE $where AND is_question = 'y' AND flagged = 'n' ORDER BY date DESC LIMIT $offset, $rows");
	$number_of_records = count($db->get_results("SELECT $select FROM $tables WHERE $where AND is_question = 'y' AND flagged = 'n'" ));
}else{
	$latest = $db->get_results("SELECT * FROM " . TABLES_PREFIX . "posts WHERE is_question = 'y' AND flagged = 'n' ORDER BY date DESC LIMIT $offset, $rows");
	$number_of_records = count($db->get_results("SELECT * FROM " . TABLES_PREFIX . "posts WHERE is_question = 'y' AND flagged = 'n'" ));
}


$number_of_pages = ceil( $number_of_records / $rows );

$rows_html = '';
if($latest){
	foreach($latest as $post){
		$row_layout = new Layout('html/','str/');
		$row_layout->SetContentView('home-rows');
		$row_layout->AddContentById('id', $post->id);
		
		if($post->locked == 'y'){
			$row_layout->AddContentById('title', TrimText($post->title, 38));
			$row_layout->AddContentById('locked', '({{ST:locked}})');
		}else{
			$row_layout->AddContentById('title', TrimText($post->title, 46));
		}
		$row_layout->AddContentById('question', preg_replace('/\v+|\\\[rn]/','<br/>',TrimText($post->body, 200)));
		
		$row_layout->AddContentById('likes', NiceNumber($post->likes));
		$row_layout->AddContentById('views', NiceNumber($post->views));
		
		$row_layout->AddContentById('date', getRelativeTime($post->date));
		
		$row_layout->AddContentById('replies', count($db->get_results("SELECT * FROM " . TABLES_PREFIX . "posts WHERE parent_id = " . $post->id )));
		
		$row_layout->AddContentById('category_id', $post->category_id);
		$row_layout->AddContentById('category_name', $db->get_var("SELECT name FROM " . TABLES_PREFIX . "categories WHERE id = " . $post->category_id));
		
		if(Users_IsUserAdmin($post->user_id)){
			$row_layout->AddContentById('is_admin', '<p><span class="label label-warning">{{ST:is_admin}}</span></p>');
		}
		$row_layout->AddContentById('user_id', $post->user_id);
		
		$user_details = Users_GetUserDetails($post->user_id);
		if($user_details){
			if($user_details['username']){
				$row_layout->AddContentById('user_name', $user_details['username']);
			}
			if($user_details['path_to_profile']){
				$row_layout->AddContentById('path_to_profile', $user_details['path_to_profile']);
			}
			if($user_details['path_to_photo']){
				$row_layout->AddContentById('user_photo', $user_details['path_to_photo']);
			}else{
				$row_layout->AddContentById('user_photo', 'img/anon.png');
			}
		}
		
		$rows_html .= $row_layout-> ReturnView();
	}
	
	if($number_of_records>$rows){
		if(isset($_GET['id'])){
			$pagination = Paginate('index.php?id='.intval($_GET['id']), $page, $number_of_pages, true, 3);
		}elseif(isset($_GET['mine'])){
			$pagination = Paginate('index.php?mine=1', $page, $number_of_pages, true, 3);
		}elseif(isset($_GET['following'])){
			$pagination = Paginate('index.php?following=1', $page, $number_of_pages, true, 3);
		}else{
			$pagination = Paginate('index.php', $page, $number_of_pages, false, 3);
		}
		$layout->AddContentById('pagination', $pagination);
	}
	
}else{
	$rows_html = '<p>{{ST:there_are_no_posts}}</p>';
}



$layout->AddContentById('rows', $rows_html);


$layout->RenderViewAndExit();
