<?php

function NotifySubscribers($question, $answer){
	
	$db = new Db;
	$strings = new StringResource('str/');
	
	$question_title = $db->get_var("SELECT title FROM " . TABLES_PREFIX . "posts WHERE id = " . intval($question));
	$answers_body = $db->get_var("SELECT body FROM " . TABLES_PREFIX . "posts WHERE id = " . intval($answer));
	
	$subject = '[' . $_SERVER['SERVER_NAME'] . '] ' . $question_title;
	$from = WEBMASTER_EMAIL;
	$to = array();
	$body = $strings->Get('question_title') .': ' . $question_title . '

' . $answers_body . '

' . FORUM_URL . 'thread.php?id=' . $question;
	
	$users = $db->get_results("SELECT * FROM " . TABLES_PREFIX . "posts_following WHERE post_id = ".intval($question)."");
	
	if($users){
		foreach($users as $user){
			if(intval($user->user_id) != Users_CurrentUserId()){
				$details = Users_GetUserDetails($user->user_id);
				if($details['email']){
					$to[] = $details['email'];
				}
			}
		}
			
	}
	
	if($to){
		$headers = "From: $from";
		ini_set("sendmail_from", $from);
		foreach($to as $t){
			mail($t,$subject,$body,$headers);
		}

	}
}

function GetPage($content_html_file = '', $title = ''){
	$layout = new Layout('html/','str/');
	$layout->SetContentView('base');
	$layout->AddContentById('content', $layout->GetContent($content_html_file));
	$layout->AddContentById('title', $title);
	$layout->AddContentById('current_year', date('Y'));
	$layout->AddContentById('site_url', SITE_URL);
	if(Users_IsUserLoggedIn()){
		$layout->AddContentById('my_profile_link', '<p class="navbar-text pull-right">{{ST:logged_in_as}} <a href="'.Users_ChangeProfilePageUrlCurrentUser().'">' .Users_CurrentUserUsername().'</a> | <a href="'.Users_SignOutPageUrl().'">{{ST:signout}}</a></p>');
		
		$layout->AddContentById('sidebar', $layout->GetContent('sidebar-signin'));
		
		
		
		if(Users_IsUserAdmin(Users_CurrentUserId())){
			$layout->AddContentById('admin-sidebar', $layout->GetContent('sidebar-admin'));
		}else{
			$layout->AddContentById('admin-sidebar', '');
		}
	}else{
		$layout->AddContentById('sidebar', $layout->GetContent('sidebar-signout'));
		
		$layout->AddContentById('signin_url', Users_SignInPageUrl());
		$layout->AddContentById('signup_url', Users_RegistrationPageUrl());
		$layout->AddContentById('forgot_url', Users_ForgotPasswordPageUrl());
	}
	
	$db = new Db;
	$categories = $db->get_results("SELECT * FROM " . TABLES_PREFIX . "categories ORDER BY name ASC");
	
	$rows_html = '';
	$count = 1;
	if($categories){
		foreach($categories as $category){
			$rows_html .= '<h4><a href="index.php?id='.$category->id.'">'.$count.'. '.$category->name.' ('.count($db->get_results("SELECT * FROM " . TABLES_PREFIX . "posts WHERE category_id = " . intval($category->id) )).')</a></h4>';
			$count++;
		}
	}
	$layout->AddContentById('sidebar_forums', $rows_html);
	
	
	return $layout;
}

function Paginate($url, $page, $total_pages, $already_has_query_str = false, $adjacents = 3) {
	
	$prevlabel = "&larr;";
	$nextlabel = "&rarr;";
	
	if($already_has_query_str == true){
		$start_with = '&';
	}else{
		$start_with = '?';
	}
	
	$out = '<div class="pagination"><ul>';
	
	// previous
	if($page == 1){
		$out.= '<li class="disabled"><a href="#">&larr;</a></li>';
	}else {
		$out.= '<li><a href="' . $url . $start_with . 'page=' . ($page-1) . '">&larr;</a></li>';
	}
	
	// first
	if($page > ($adjacents + 1)) {
		$out.= '<li><a href="' . $url . $start_with . 'page=' . 1 . '">1</a></li>';
	}
	
	// interval
	if($page > ($adjacents + 2)) {
		$out.= '<li class="disabled"><a href="#">...</a></li>';
	}
	
	// pages
	$pmin = ($page > $adjacents) ? ($page - $adjacents) : 1;
	$pmax = ($page < ($total_pages - $adjacents)) ? ($page + $adjacents) : $total_pages;
	for($i=$pmin; $i<=$pmax; $i++) {
		if($i==$page) {
			$out.= '<li class="disabled"><a href="#">' . $i . '</a></li>';
			
		}else{
			$out.= '<li><a href="' . $url . $start_with . 'page=' . $i . '">' . $i . '</a></li>';
		}
	}
	
	// interval
	if($page<($total_pages-$adjacents-1)) {
		$out.= '<li class="disabled"><a href="#">...</a></li>';
	}
	
	// last
	if($page<($total_pages-$adjacents)) {
		$out.= '<li><a href="' . $url . $start_with . 'page=' . $total_pages . '">' . $total_pages . '</a></li>';
	}
	
	// next
	if($page<$total_pages) {
		$out.= '<li><a href="' . $url . $start_with . 'page=' . ($page+1) . '">&rarr;</a></li>';
	}
	else {
		$out.= '<li class="disabled"><a href="#">&rarr;</a></li>';
	}
	
	$out.= '</ul></div>';
	
	return $out;
}

function ValidateEmail($email){
   	if (preg_match("/[\\000-\\037]/",$email)) {
      		return false;
   	}
   	$pattern = "/^[-_a-z0-9\'+*$^&%=~!?{}]++(?:\.[-_a-z0-9\'+*$^&%=~!?{}]+)*+@(?:(?![-.])[-a-z0-9.]+(?<![-.])\.[a-z]{2,6}|\d{1,3}(?:\.\d{1,3}){3})(?::\d++)?$/iD";
   	if(!preg_match($pattern, $email)){
      		return false;
   	}
   	return true;
}

function encode_password($password){
	
	return md5($password);
}

function GeneratePassword($len = 8){
	if(!$len)
		$len = 8;	
	$pool = '123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
	$str = '';
	for ($i = 0; $i < $len; $i++){
		$str .= substr($pool, mt_rand(0, strlen($pool) -1), 1);
	}
	return $str;
}


function NiceNumber($n) {
	$n = (0+str_replace(",","",$n));
	if(!is_numeric($n)) return false;
	if($n>1000000000000) return round(($n/1000000000000),1).'Tri';
	else if($n>1000000000) return round(($n/1000000000),1).' Bil';
	else if($n>1000000) return round(($n/1000000),1).'Mil';
	else if($n>1000) return round(($n/1000),1).'K';
	return number_format($n);
}

function plural($num) {
    if ($num != 1)
    return "s";
    }
     
    function getRelativeTime($date) {
    	$diff = time() - strtotime($date);
   	if ($diff<60)
   		 return $diff . " second" . plural($diff) . " ago";
    	$diff = round($diff/60);
    	if ($diff<60)
    		return $diff . " minute" . plural($diff) . " ago";
   	 $diff = round($diff/60);
    	if ($diff<24)
    		return $diff . " hour" . plural($diff) . " ago";
    	$diff = round($diff/24);
    	if ($diff<7)
    		return $diff . " day" . plural($diff) . " ago";
    	$diff = round($diff/7);
    	if ($diff<4)
    		return $diff . " week" . plural($diff) . " ago";
   	return "on " . date("F j, Y", strtotime($date));
    }

function TrimText($input, $length) {
    $input = strip_tags($input);
    if (strlen($input) <= $length) {
        return $input;
    }
    $last_space = strrpos(substr($input, 0, $length), ' ');
    $trimmed_text = substr($input, 0, $last_space);
  
    $trimmed_text .= '&hellip;';
  
    return $trimmed_text;
}

function Leave($url){
	header("Location: $url");
	exit;
}

function is_image_file($name){
	$img_extensions = 'gif|png|jpg|jpeg|jpe';
	return valid_file_extension($name, $img_extensions);
}

function valid_file_extension($name, $allowed_extensions){
	$allowed_extensions = explode('|', $allowed_extensions);
	$extension = strtolower(get_extension($name));
	if(in_array($extension, $allowed_extensions, TRUE)){
		return true;
	}else{
		return false;
	}	
	return true;
}
	
function get_extension($filename){
	$x = explode('.', $filename);
	return end($x);
}
	
function clean_file_name($filename){
	$invalid = array("<!--","-->","'","<",">",'"','&','$','=',';','?','/',"%20","%22","%3c","%253c","%3e","%0e","%28","%29","%2528","%26","%24","%3f","%3b", "%3d");		
	$filename = str_replace($invalid, '', $filename);
	$filename = preg_replace("/\s+/", "_", $filename);
	return stripslashes($filename);
}
	
function set_filename($path, $filename){
	$file_ext = get_extension($filename);
	if ( ! file_exists($path.$filename)){
		return $filename;
	}
	$new_filename = str_replace('.'.$file_ext, '', $filename);
	for ($i = 1; $i < 300; $i++){			
		if ( ! file_exists($path.$new_filename.'_'.$i.'.'.$file_ext)){
			$new_filename .= '_'.$i.'.'.$file_ext;
			break;
		}
	}
	return $new_filename;
}

function UploadError($code){
	$response = '';	
	switch ($code) {
        case UPLOAD_ERR_INI_SIZE:
            $response = '{{ST:UPLOAD_ERR_INI_SIZE}}';
            break;
        case UPLOAD_ERR_FORM_SIZE:
            $response = '{{ST:UPLOAD_ERR_FORM_SIZE}}';
            break;
        case UPLOAD_ERR_PARTIAL:
            $response = '{{ST:UPLOAD_ERR_PARTIAL}}';
            break;
        case UPLOAD_ERR_NO_FILE:
            $response = '{{ST:UPLOAD_ERR_NO_FILE}}';
            break;
        case UPLOAD_ERR_NO_TMP_DIR:
            $response = '{{ST:UPLOAD_ERR_NO_TMP_DIR}}';
            break;
        case UPLOAD_ERR_CANT_WRITE:
            $response = '{{ST:UPLOAD_ERR_CANT_WRITE}}';
            break;
        case UPLOAD_ERR_EXTENSION:
            $response = '{{ST:UPLOAD_ERR_EXTENSION}}';
            break;
        default:
            $response = '{{ST:Unknown_error_file_error}}';
            break;
    }
 
    return $response;
}
