<?php

//Check if there is an active session
//Return boolean
function Users_IsUserLoggedIn(){
	if(isset($_SESSION['sforum_logged_in']) AND ($_SESSION['sforum_logged_in'] == true)){
		return true;
	}else{
		return false;
	}
}

//Checks if the user with the $id is an administrator
//Return boolean
function Users_IsUserAdmin($id){
	if(!$id)
		return false;
	
	$db = new Db;
	$user = $db->get_row("SELECT * FROM " . TABLES_PREFIX . "users WHERE id = $id ORDER BY id DESC LIMIT 0,1");
	if($user AND ($user->role == 'admin')){
		return true;
	}else{
		return false;
	}
}

//Check if the current user is able to start threads and reply to them
//Return boolean
function Users_CanCurrentUserPost(){
	if(!Users_CurrentUserId())
		return false;
	$id = intval(Users_CurrentUserId());
	$db = new Db;
	$user = $db->get_row("SELECT * FROM " . TABLES_PREFIX . "users WHERE id = $id ORDER BY id DESC LIMIT 0,1");
	if($user AND ($user->status == 'active')){
		return true;
	}else{
		return false;
	}
}

//Gets the current user's ID
//Return an integer
function Users_CurrentUserId(){
	if(isset($_SESSION['sforum_user_id'])){
		return intval($_SESSION['sforum_user_id']);
	}else{
		return null;
	}
}

//Gets the current user's username
//Return an string
function Users_CurrentUserUsername(){
	if(!Users_CurrentUserId())
		return '';
	$id = intval(Users_CurrentUserId());
	$db = new Db;
	$user = $db->get_row("SELECT * FROM " . TABLES_PREFIX . "users WHERE id = $id ORDER BY id DESC LIMIT 0,1");
	if($user){
		return $user->username;
	}else{
		return '';
	}
}

//Gets the details of the user with the $id
//path_to_photo and bio are optional. Everything else is required.
//Return an array: array('id'=>[int],'username'=>[string],'email'=>[string],'path_to_photo'=>[string],'is_admin'=>[bool],'bio'=>[string])
function Users_GetUserDetails($id){
	$return = array('id'=>null,'username'=>'','email'=>'','path_to_photo'=>'','is_admin'=>false,'bio'=>'');
	$db = new Db;
	$user = $db->get_row("SELECT * FROM " . TABLES_PREFIX . "users WHERE id = $id ORDER BY id DESC LIMIT 0,1");
	if($user){
		$return['id'] = $user->id;
		$return['username'] = $user->username;
		$return['email'] = $user->email;
		$return['is_admin'] = Users_IsUserAdmin($user->id);
		$return['path_to_photo'] = $user->photo;
		$return['bio'] = $user->bio;
		$return['path_to_profile'] = 'profiles.php?id='.$user->id;
	}
	return $return;
}

//The page to direct users to sign in
//Return an string
function Users_SignInPageUrl(){
	return FORUM_URL . 'signin.php';
}

//The page to direct users to sign pout
//Return an string
function Users_SignOutPageUrl(){
	return FORUM_URL . 'signout.php';
}

//The page to direct users to sign up
//Return an string
function Users_RegistrationPageUrl(){
	return FORUM_URL . 'signup.php';
}

//The page to direct users when they have forgotten their password
//Return an string
function Users_ForgotPasswordPageUrl(){
	return FORUM_URL . 'forgot.php';
}

//The page to direct users to change their details
//Return an string
function Users_ChangeProfilePageUrlCurrentUser(){
	return FORUM_URL . 'profile.php';
}
