<?php

require 'includes.php';

$type = 'question';
if(isset($_GET['type']) AND $_GET['type'] != ''){
	$type = $_GET['type'];
}else{
	Leave("Location: index.php");
}

if($type == 'question'){
	$title = '{{ST:start_a_thread}}';
}elseif($type == 'reply'){
	$title = '{{ST:reply_to_post}}';
	if(isset($_GET['id'])){
		$id = intval($_GET['id']);
	}else{
		Leave("Location: index.php");
	}
}elseif($type == 'edit'){
	$title = '{{ST:edit_a_post}}';
	if(isset($_GET['page'])){
		$page = '&page='.intval($_GET['page']);
	}else{
		$page = '&lastpage=1';
	}
	if(isset($_GET['id'])){
		$id = intval($_GET['id']);
	}else{
		Leave("Location: index.php");
	}
	
	$post = $db->get_row("SELECT * FROM " . TABLES_PREFIX . "posts WHERE id = $id ORDER BY id DESC LIMIT 0,1");
	if(!$post){
		Leave("Location: index.php");
	}elseif(!Users_IsUserAdmin(Users_CurrentUserId())){
		if(Users_CurrentUserId() != intval($post->user_id)){
			Leave("Location: index.php");
		}
	}
}

$layout = GetPage('post', $title);

$layout->AddContentById('type', $type);

if($type == 'question'){
	$categoryQuery = $db->get_results("SELECT * FROM " . TABLES_PREFIX . "categories" );
	$categories = '';
	if($categoryQuery){
		foreach($categoryQuery as $u){
			$categories .= '<option {{ID:selected_category_' . $u->id . '}} value="' . $u->id . '">' . $u->name . '</option>';
		}
		$layout->AddContentById('categories', $categories);
	}
	$layout->AddContentById('breadcrumbs', ' <li><a href="index.php">{{ST:home}}</a> <span class="divider">/</span> </li><li class="active">{{ST:start_a_thread}}</li>');

}elseif($type == 'reply'){
	$layout->AddContentById('show_title', 'style="display: none;"');
	$layout->AddContentById('show_categories', 'style="display: none;"');
	$layout->AddContentById('id_query', '&id='.$id);
	
	$layout->AddContentById('breadcrumbs', ' <li><a href="index.php">{{ST:home}}</a> <span class="divider">/</span> </li> <li><a href="thread.php?id='.$id.'">{{ST:thread}}</a> <span class="divider">/</span> </li><li class="active">{{ST:reply_to_post}}</li>');

}elseif($type == 'edit'){
	$layout->AddContentById('show_title', 'style="display: none;"');
	$layout->AddContentById('show_categories', 'style="display: none;"');
	$layout->AddContentById('show_subscribe', 'style="display: none;"');
	$layout->AddContentById('id_query', '&id='.$id.''.$page);
	
	$layout->AddContentById('breadcrumbs', ' <li><a href="index.php">{{ST:home}}</a> <span class="divider">/</span> </li><li class="active">{{ST:edit_a_post}}</li>');
}

if(isset($_POST['submit'])){
	//$_POST = $validator->sanitize($_POST);
	$errors = false;
	$values = array();
	$format = array();
	$error_msg = '';
	
	if($type == 'question'){
		if(isset($_POST['title']) AND $_POST['title'] != ''){
			$layout->AddContentById('title_post', $_POST['title']);
			$values['title'] = $_POST['title'];
			$format[] = "%s";
		}else{
			$errors = true;
			$error_msg .= '{{ST:title_required}} ';
		}
		
		if(isset($_POST['category']) AND $_POST['category'] != ''){
			$layout->AddContentById('selected_category_' .$_POST['category'], 'selected');
			$values['category_id'] = $_POST['category'];
			$format[] = "%d";
		}else{
			$errors = true;
			$error_msg .= '{{ST:category_required}} ';
		}
	}
	
	if($type == 'reply'){
		if($db->get_var("SELECT locked FROM " . TABLES_PREFIX . "posts WHERE id = $id") == 'y'){
			$errors = true;
			$error_msg .= '{{ST:thread_is_locked}} ';
		}
	}
	
	if(isset($_POST['body']) AND $_POST['body'] != ''){
		$layout->AddContentById('body', $_POST['body']);
		$values['body'] = $_POST['body'];
		$format[] = "%s";
	}else{
		$errors = true;
		$error_msg .= '{{ST:body_required}} ';
	}
	
	if(isset($_POST['email_notification'])){
		$layout->AddContentById('email_notification_state', 'checked="checked"');
	}
	
	if(!Users_IsUserLoggedIn()){
			$errors = true;
			$error_msg .= '{{ST:you_need_to_signin_first}} ';
	}elseif(!Users_CanCurrentUserPost()){
			$errors = true;
			$error_msg .= '{{ST:you_are_not_able_to_post_contact_admin}} ';
	}
	
	if(!$errors){
		if($type == 'question' OR $type == 'reply'){
			if($type == 'question'){
				$values['is_question'] = 'y';
				$format[] = "%s";
			}else{
				$values['is_question'] = 'n';
				$format[] = "%s";
				$values['parent_id'] = $id;
				$format[] = "%d";
			}
			$values['flagged'] = 'n';
			$format[] = "%s";
			$values['likes'] = 0;
			$format[] = "%d";
			$values['date'] = date('Y-m-d H:i:s');
			$format[] = "%s";
			$values['user_id'] = Users_CurrentUserId();
			$format[] = "%d";
			
			if($db->insert(TABLES_PREFIX . "posts", $values, $format)){
				$new_record = $db->insert_id;
				if(isset($_POST['email_notification'])){
					$db->insert(TABLES_PREFIX . "posts_following", array('post_id'=>$id,'user_id'=>Users_CurrentUserId()), array("%d","%d"));
				}
				if($type == 'question'){
					Leave('thread.php?id=' . $new_record);
				}else{
					NotifySubscribers($id, $new_record);
					Leave('thread.php?id=' . $id . '&lastpage=1');
				}
			}else{
				$layout->AddContentById('alert', $layout->GetContent('alert'));
				$layout->AddContentById('alert_nature', ' alert-error');
				$layout->AddContentById('alert_heading', '{{ST:error}}!');
				$layout->AddContentById('alert_message', '{{ST:unknow_error_try_again}}');
			}
		}elseif($type == 'edit'){
			if($post->body != $values['body']){
				$values['last_edited_on'] = date('Y-m-d H:i:s');
				$format[] = "%s";
				$values['last_edited_by'] = Users_CurrentUserId();
				$format[] = "%d";
			}
			$db->update(TABLES_PREFIX . "posts", $values, array('id'=>$id), $format);
			
			if($post->is_question == 'y'){
				Leave('thread.php?id=' . $id);
			}else{
				Leave('thread.php?id=' . $post->parent_id . $page);
			}
		}
	}else{
		$layout->AddContentById('alert', $layout->GetContent('alert'));
		$layout->AddContentById('alert_nature', ' alert-error');
		$layout->AddContentById('alert_heading', '{{ST:error}}!');
		$layout->AddContentById('alert_message', $error_msg);
	}
}else{
	if($type == 'edit'){
		$layout->AddContentById('body', $post->body);
	}
	if(!Users_IsUserLoggedIn()){
			$layout->AddContentById('alert', $layout->GetContent('alert'));
			$layout->AddContentById('alert_nature', ' alert-error');
			$layout->AddContentById('alert_heading', '{{ST:info}}:');
			$layout->AddContentById('alert_message', '{{ST:you_need_to_signin_first}}');
	}elseif(!Users_CanCurrentUserPost()){
			$layout->AddContentById('alert', $layout->GetContent('alert'));
			$layout->AddContentById('alert_nature', ' alert-error');
			$layout->AddContentById('alert_heading', '{{ST:info}}:');
			$layout->AddContentById('alert_message', '{{ST:you_are_not_able_to_post_contact_admin}}');
	}
}



$layout->RenderViewAndExit();
