<?php

require 'includes.php';

if(!Users_IsUserLoggedIn() OR !Users_IsUserAdmin(Users_CurrentUserId())){
	Leave('index.php');
}

$layout = GetPage('user', '{{ST:user_management}}');
$layout->AddContentById('breadcrumbs', ' <li><a href="index.php">{{ST:home}}</a> <span class="divider">/</span> </li> <li><a href="users.php">{{ST:user_management}}</a> <span class="divider">/</span> </li><li class="active">{{ST:edit_user}}</li>');


if(isset($_GET['id'])){
	$id = intval($_GET['id']);
}else{
	Leave('users.php');
}

$admin = $db->get_row("SELECT * FROM " . TABLES_PREFIX . "users WHERE id = $id ORDER BY id DESC LIMIT 0,1");

if(isset($_POST['delete'])){
	$db->query("DELETE FROM " . TABLES_PREFIX . "users WHERE id = " . $id);
	$db->query("DELETE FROM " . TABLES_PREFIX . "posts_following WHERE user_id = " . $id);
	Leave('users.php');
}

$layout->AddContentById('id', $admin->id);

if(isset($_POST['submit'])){
	$_POST = $validator->sanitize($_POST);
	$errors = false;
	$values = array();
	$format = array();
	$error_msg = '';
	
	if(isset($_POST['email']) AND $_POST['email'] != ''){
		$layout->AddContentById('email', $_POST['email']);
		$check_email = $db->get_row("SELECT * FROM " . TABLES_PREFIX . "users WHERE email = '" . $_POST['email'] . "' ORDER BY id DESC LIMIT 0,1");
		if($check_email AND intval($check_email->id) != $id){
			$errors = true;
			$error_msg .=  '{{ST:email_already_in_use}} ';
		}elseif(!ValidateEmail($_POST['email'])){
			$errors = true;
			$error_msg .=  '{{ST:email_is_invalid}} ';
		}else{
			$values['email'] = $_POST['email'];
			$format[] = "%s";
		}
	}else{
		$errors = true;
		$error_msg .= '{{ST:email_required}} ';
	}
	
	
	if(isset($_POST['username']) AND $_POST['username'] != ''){
		$layout->AddContentById('username', $_POST['username']);
		$check_username = $db->get_row("SELECT * FROM " . TABLES_PREFIX . "users WHERE username = '" . $_POST['username'] . "' ORDER BY id DESC LIMIT 0,1");
		if($check_username AND intval($check_username->id) != $id){
			$errors = true;
			$error_msg .=  '{{ST:username_already_in_use}} ';
		}else{
			$values['username'] = $_POST['username'];
			$format[] = "%s";
		}
	}else{
		$errors = true;
		$error_msg .= '{{ST:username_required}} ';
	}
	
	if(isset($_POST['role']) AND $_POST['role'] != ''){
		$layout->AddContentById($_POST['role'].'_selected', 'selected');
		$values['role'] = $_POST['role'];
		$format[] = "%s";
	}else{
		$errors = true;
		$error_msg .= '{{ST:role_required}} ';
	}
	
	
	if(isset($_POST['deny_access'])){
		$values['status'] = 'banned';
		$format[] = "%s";
		$layout->AddContentById('deny_access_state', 'checked="checked"');
	}else{
		$values['status'] = 'active';
		$format[] = "%s";
	}
	
	if(!$errors){
		$db->update(TABLES_PREFIX . "users", $values, array('id'=>$id), $format);
		$layout->AddContentById('alert', $layout->GetContent('alert'));
		$layout->AddContentById('alert_nature', ' alert-success');
		$layout->AddContentById('alert_heading', '{{ST:success}}!');
		$layout->AddContentById('alert_message', '{{ST:the_item_has_been_saved}}');
	}else{
		$layout->AddContentById('alert', $layout->GetContent('alert'));
		$layout->AddContentById('alert_nature', ' alert-error');
		$layout->AddContentById('alert_heading', '{{ST:error}}!');
		$layout->AddContentById('alert_message', $error_msg);
	}
}else{
	
	$layout->AddContentById('username', $admin->username);
	$layout->AddContentById('email', $admin->email);
	
	if($admin->status == 'banned'){
		$layout->AddContentById('deny_access_state', 'checked="checked"');
	}
	
	$layout->AddContentById($admin->role.'_selected', 'selected');
	
}

$layout->RenderViewAndExit();
